# make sure to add config.ini inside root of your directory before running docker-compose up
version: '3.8'
services:
  mariadb:
    image: mariadb
    container_name: mariadb
    ports:
      - 3306:3306
    volumes:
      - mariadb_data:/var/lib/mysql
      - ${PWD}/mariadb-init:/docker-entrypoint-initdb.d #Provide priveleges access to lingualibre user
    environment:
      MARIADB_ROOT_PASSWORD: abcd # Can be anything, will not be used by application
      MARIADB_DATABASE: lingualibre # Same as config.ini database name
      MARIADB_USER: lingualibre # Same as config.ini database user
      MARIADB_PASSWORD: abcd # Same as config.ini password

  backend:
    build: .
    container_name: backend
    ports:
      - 8080:8080
    volumes:
      - .:/app
    depends_on:
      - mariadb

  client:
    build: ./front-end
    container_name: client
    ports:
      - 8079:8079
    volumes:
      - ./front-end:/app
      - /app/node_modules # Prevents node_modules from being overwritten
    depends_on:
      - backend

volumes:
  mariadb_data:

# TODO:
# Add bind-mounts so that all changes can be viewed live (will require some changes in front-end Docketfile)
# Add a bind mount from config.ini file so that configs are not pushed to docker image